# $locale->text('General Ledger Summary')


use SL::battotal;
use POSIX qw(strftime);
$form->{rowcount}=30;
1;

sub search {

  $form->{title} = $locale->text($form->{title});

  $form->header;

  print qq|
  <script>
<!--
function stb(){parent.document.title ="$form->{title}";}

	// -->
</script>
<body bgcolor=ffffff  onLoad=stb()>

<form method=post action=$form->{script} name=myform>

<!--input type=hidden name=sort value=transdate-->
<input type=hidden name=sort value=transtype>
<input type=hidden name=title value="$form->{title}">

<table border=1>
<tr><th class=listtop bgcolor=000000><font color=ffffff>$form->{title}</font></th></tr>

<tr valign=top>
<td>
<table>



<tr>

  <th align=right>|.$locale->text('From').qq|   </th>
  <td><input name=datefrom size=11 title=($myconfig{dateformat})>
      <link rel="stylesheet" media="screen" href="javascript/dynCalendar.css" />
<script language="javascript" type="text/javascript" src="javascript/browserSniffer.js"></script>
<script language="javascript" type="text/javascript" src="javascript/dynCalendar.js"></script>
 
   <script language="JavaScript" type="text/javascript">
    <!--
        /**
        * Example callback function
        */
        function calendar1Callback(date, month, year)
        {
            document.forms['myform'].datefrom.value = formatDate(new Date(getDateFromFormat(year + '-' + month + '-' + date,'yyyy-M-d')),'$myconfig{dateformat}');
        }

        calendar1 = new dynCalendar('calendar1', 'calendar1Callback', 'javascript/images/');
    //-->
    </script>
  </td>
  <th align=right>|.$locale->text('To').qq|</th>
  <td><input name=dateto size=11 title=($myconfig{dateformat})>
     <script language="JavaScript" type="text/javascript">
    <!--
        /**
        * Example callback function
        */
        function calendar1Callback2(date, month, year)
        {
            document.forms['myform'].dateto.value = formatDate(new Date(getDateFromFormat(year + '-' + month + '-' + date,'yyyy-M-d')),'$myconfig{dateformat}');
        }

        calendar2 = new dynCalendar('calendar2', 'calendar1Callback2', 'javascript/images/');
    //-->
    </script>

  </td>

</tr>
<tr>
	<th align=right>|.$locale->text('Group By').qq|</th>
	<td><select name=groupby> <option value=0>|.$locale->text('Trans Type').qq| <option value=1>|.$locale->text('Project').qq|

</tr>



<tr>
|;
#if($form->{subtitle} eq "GENERAL LEDGER"){
  print qq|<th align=right>|.$locale->text('Include in Report').qq|</th>
  <td colspan=3>    
    <input name="l_sr" class=checkbox type=checkbox value=Y $form->{l_sr}>&nbsp;|.$locale->text('SR').qq|
    <input name="l_diff" class=checkbox type=checkbox value=Y $form->{l_diff}>&nbsp;|.$locale->text('Difference').qq|
    <input name="l_not" class=checkbox type=checkbox value=Y $form->{l_not}>&nbsp;|.$locale->text('Total Trans').qq|
    <input name="l_debit" class=checkbox type=checkbox value=Y $form->{l_debit}>&nbsp;|.$locale->text('Debit').qq|<br>
    <input name="l_credit" class=checkbox type=checkbox value=Y $form->{l_credit}>&nbsp;|.$locale->text('Credit').qq|
    <input name="l_batch" class=checkbox type=checkbox value=Y $form->{l_batch}>&nbsp;|.$locale->text('Trans No.').qq|
    <input name="l_total" class=checkbox type=checkbox value=Y $form->{l_total}>&nbsp;|.$locale->text('Total').qq|
    </td>
  </tr>|;
#}




print qq|
</table>
</td>

</tr>
</table>
<input type=hidden name=rowcount value=$form->{rowcount}>

<input type=hidden name=path value=$form->{path}>
<input type=hidden name=login value=$form->{login}>
<input type=hidden name=sessionid value=$form->{sessionid}>
<br>
<input class=submit type=submit name=action value="|.$locale->text('Continue').qq|">
<input class=submit type=submit name=action value="|.$locale->text('Print').qq|">


</form>

<p>
|.$locale->text('To display all transactions, leave fields blank')

  .qq|

</body>
</html>
|;
}
sub continue{
	&generate_battotal_report;
}
sub print{
	&generate_battotal_print;

}

######################################################################################################################################
sub generate_battotal_print {
 $form->{print}="true";
&generate_battotal_all;
}

sub generate_battotal_report {
	&generate_battotal_all;
}

sub generate_battotal_all {
   map { $form->{$_} = $myconfig{$_} } (qw(company address businessnumber nativecurr fy));
 if(!$form->{print}){
    $listheading="class=listheading";
    $listheadingcolor="color=ffffff";
    $listtop="class=listtop";
    $listrow="class=listrow";
    $listtotal="class=listtotal";
    $listsubtotal="class=listsubtotal";
    $lastline=$locale->text('Click on "Ref No." to edit transaction');
    $mouseaction[0]=" onmouseover=\"this.className = 'listover';\" onmouseout=\"this.className = 'listrow0';\"";
    $mouseaction[1]=" onmouseover=\"this.className = 'listover';\" onmouseout=\"this.className = 'listrow1';\"";
      }else{
    $line = "<hr size=3 noshade>";
    $fontsize="size=2";
    $listprint="class=print";
    $listheading="class=print";
    $listtop="class=print";
    $listrow="class=print";
    $listsubtotal="class=print";
  }
  
  #GL->all_transactions2(\%myconfig, \%$form);
  battotal->BATTOTAL(\%myconfig, \%$form);

  #14/10 Change to Cheque No in BP
  $form->{transtypeno1} = $form->{transtypeno};
  $form->{transtypeno1} =~ tr/0123456789-//d;
  
   $form->{title} =~ s/ /%20/g;
 
   $callback = "$form->{script}?action=generate_battotal_all&path=$form->{path}&login=$form->{login}&sessionid=$form->{sessionid}&print=$form->{print}&title=$form->{title}&nextfocus=transtype";
   $form->{title} =~ s/%20/ /g;
       $form->{title} = $locale->text($form->{title});

  %acctype = ( 'A' => $locale->text('Asset'),
               'L' => $locale->text('Liability'),
	       'Q' => $locale->text('Equity'),
	       'I' => $locale->text('Income'),
	       'E' => $locale->text('Expense'),
	     );

  unless ($form->{category} eq 'X') {
    $form->{title} .= " : ".$locale->text($acctype{$form->{category}});
  }
   if ($form->{datefrom}) {
    $callback .= "&datefrom=$form->{datefrom}";
    $option .= "\n<br>" if $option;
    $option .= $locale->text('From')." ".$locale->date(\%myconfig, $form->{datefrom}, 1);
  }
  if ($form->{dateto}) {
    $callback .= "&dateto=$form->{dateto}";
    if ($form->{datefrom}) {
      $option .= " ";
    } else {
      $option .= "\n<br>" if $option;
    }
    $option .= $locale->text('To')." ".$locale->date(\%myconfig, $form->{dateto}, 1);
  }
  


  @columns = qw( project subb   batch not   debit credit   diff  );

  $href = "$callback&sort=$form->{sort}";        # needed for accno

  foreach $item (@columns) {
    if ($form->{"l_$item"} eq "Y") {
      push @column_index, $item;

      # add column to href and callback
      $callback .= "&l_$item=Y";
      $href .= "&l_$item=Y";
    }
  }

  if ($form->{l_subtotal} eq 'Y') {
    $callback .= "&l_subtotal=Y";
    $href .= "&l_subtotal=Y";
  }

  if ($form->{l_total} eq 'Y') {
    $callback .= "&l_total=Y";
    $href .= "&l_total=Y";
  }
    if ($form->{l_description} eq 'Y') {
    $callback .= "&l_description=Y";
    $href .= "&l_description=Y";
  }
  
    if ($form->{l_sr} eq 'Y') {
    $callback .= "&l_sr=Y";
    $href .= "&l_sr=Y";
  }

  $callback .= "&category=$form->{category}";
  $href .= "&category=$form->{category}";

      if($form->{groupby} == 0 ){
	  $transtype="transtypeno";
	  $batch = "batchno";
	  $sort="transtype";
	  $header="Trans No.";
  }
    if($form->{groupby} == 1 ){
	  $transtype="projectno";
	  $batch = "subbno";
	  $sort="project";
	  $header="Project";
  }
	


  $column_header{diff} = "<th $listprint>$line<font $fontsize $listheadingcolor>".$locale->text('Difference')."</font>$line</th>";
  $column_header{debit} = "<th $listprint >$line<font $fontsize $listheadingcolor><a $listprint href=$callback&sort=debit>".$locale->text('Debit')."</a></font>$line</th>";
  $column_header{credit} = "<th $listprint >$line<font $fontsize $listheadingcolor><a $listprint href=$callback&sort=credit>".$locale->text('Credit')."</a></font>$line</th>";
  $column_header{not} = "<th $listprint >$line<a $listprint href=$callback&sort=notr><font $fontsize $listheadingcolor>".$locale->text('N.O.T.')."</a></font>$line</th>";
  $column_header{batch} = "<th $listprint >$line<a $listprint href=$callback&sort=transtype><font $fontsize $listheadingcolor>".$locale->text($header)."</a></font>$line</th>";
 # $column_header{subb} = "<th $listprint >$line<a $listprint href=$callback&sort=subb><font $fontsize $listheadingcolor>".$locale->text('Sub No.')."</a></font>$line</th>";
 # $column_header{project} = "<th $listprint >$line<a $listprint href=$callback&sort=project><font $fontsize $listheadingcolor>".$locale->text('Project No.')."</a></font>$line</th>";
  
  $colspan = $#column_index + 1;

  
  #15/10 set latest date and time
  $nowdate = strftime "%d%m%y", localtime;
  $nowtime = strftime "%I%M ", localtime;
	
	
  #10/10 extract the db name
  ($dbname) = split /\_/, $myconfig{dbname};
  $dbname =~ tr/a-z/A-Z/;
  
  
  #14/10 page number at right upper corner
  $pagenumber = 1;
  $form->header(1);
  
  #14/10 move the company name and title to top of the page
  print  qq|

<body bgcolor=ffffff $listprint>
<table border=0 width=100%>
	<tr>
		<td align=left width=100>

		
		<td align=center width=100%>		
		<table border=0 width=100%>
		<tr>
			<th align=center><font size=3>$form->{company}</font></th>
		</tr>
		<tr>
			<th align=center><font size=3>|.$locale->text('General Ledger Summary').qq|</font></th>
		</tr>
		</table>
		
		</td>
		
	</tr>
</table>
<!--p $listprint><font size=3>$dbname</font></p>
<p $listprint><font size=3>F/Y : $form->{fy}</font></p>
<H1  $listprint  align=center><font size=4>$form->{company}<br>$form->{title}</font></H1-->
|;
#$option
  print  qq|

<table $listprint border=0 width=100%>


<thead $listheading bgcolor=336666>
|;
if($form->{l_sr}){
	print "<th $listprint>$line<font $fontsize $listheadingcolor>".$locale->text('SR')."$line</th>";
}
map { print  "$column_header{$_}\n" } @column_index;

print  "</thead>";

  # add sort to callback
  $callback = $form->escape($callback . "&sort=$form->{sort}");

  # initial item for subtotals
  if (@{ $form->{GL} }) {
    $sameitem = $form->{GL}->[0]->{$form->{sort}};
  }

  foreach $ref (@{ $form->{GL} }) {

    # if item ne sort print subtotal
    if ($form->{l_subtotal} eq 'Y') {
      if ($sameitem ne $ref->{$form->{sort}}) {
	&gl_subtotal;
      }
    }	
 $gltitle = $form->escape("General Ledger Reports");
	
    $subtotaldebit += $ref->{debit};
    $subtotalcredit += $ref->{credit};
    $subtotalamount += $ref->{amount};

    $totaldebit += $ref->{debit};
    $totalcredit += $ref->{credit};
    $totalamount += $ref->{amount};
    
    
    #total the +ve amount amount
    if($ref->{amount} > 0){
    	$pagetotalamount += $ref->{amount};
    }

    		
    $pagetotaldebit += $ref->{debit};
    $pagetotalcredit += $ref->{credit};
  
  $difference = $ref->{debit} - $ref->{credit};
   $totalnotr += $ref->{notr};
 $totaldif += $difference;
  $newdebit += $ref->{debit};
  $newcredit += $ref->{credit};
  
  
    $ref->{debit} = $form->format_amount(\%myconfig, $ref->{debit}, 2, "&nbsp;");
    $ref->{credit} = $form->format_amount(\%myconfig, $ref->{credit}, 2, "&nbsp;");
    $ref->{amount} = $form->format_amount(\%myconfig, $ref->{amount}, 2, "&nbsp;");
    $j++;
      
		
			
	$column_data{diff} = "<td $listprint align=center><font $fontsize $listheadingcolor>".$form->format_amount(\%myconfig, $difference, 2, "0.00")."</font></td>";
    $column_data{debit} = "<td align=right $listprint><font $fontsize $listheadingcolor>$ref->{debit}</font></td>";
    $column_data{credit} = "<td align=right $listprint><font $fontsize $listheadingcolor>$ref->{credit}</font></td>";
    $column_data{amount} = "<td align=left $listprint><font $fontsize $listheadingcolor>$ref->{transtype}-$ref->{batch}</font></td>";
    $column_data{not} = "<td $listprint align=right><font $fontsize $listheadingcolor>$ref->{notr}</font></td>";
    $column_data{batch} = "<td $listprint align=left><font $fontsize $listheadingcolor><a $listprint  href=gl.pl?action=continue&nextfocus=transtype&path=$form->{path}&login=$form->{login}&sessionid=$form->{sessionid}&title=$gltitle&sort=$sort&datefrom=$form->{datefrom}&dateto=$form->{dateto}&l_sr=Y&l_transdate=Y&l_source=Y&l_description=Y&l_batch=Y&l_debit=Y&l_credit=Y&l_total=Y&l_accno=Y&l_accdesc=Y&category=X&$transtype=$ref->{transtype}&$batch=$ref->{batch}&callback=$callback>$ref->{transtype}-$ref->{batch}</a></font></td>";
   # $column_data{subb} = "<td $listprint><font $fontsize $listheadingcolor>$ref->{subb}</font></td>";
  #  $column_data{project} = "<td $listprint><font $fontsize $listheadingcolor>$ref->{project}</font></td>";
   
    $i++; $i %= 2;    $r++;
    print  "<tr $listrow$i>";
	
    if($form->{l_sr}){

    	print "<td $listprint><font $fontsize >$j</td>";
    }
    map { print "$column_data{$_}\n" } @column_index;

    print  "</tr>";
    
    #pagebreak printing
if($form->{rowcount} && $form->{print} && $form->{rowcount} <= $r){
$pagenum++;
    print "<tr $listrow$i >";
if($form->{l_sr}){
	print "<td $listprint >$line&nbsp;</td>";
}
	
    map { $column_data{$_} = "<td $listprint >$line&nbsp;</td>" } @column_index;
    $column_data{accdesc} = "<td $listprint >$line SubTotal</td>";
    $column_data{amount} = "<td  $listprint align=right>$line<font $fontsize >".$form->format_amount(\%myconfig, $pagetotalamount, 2, "&nbsp;")."</font></td>";
    $column_data{debit} = "<td  $listprint align=right>$line<font $fontsize >".$form->format_amount(\%myconfig, $pagetotaldebit , 2, "&nbsp;") . "</font></td>";
    $column_data{credit} = "<td  $listprint align=right>$line<font $fontsize >".$form->format_amount(\%myconfig, $pagetotalcredit, 2, "&nbsp;") . "</font></td>";
  
     map { print "\n$column_data{$_}" } @column_index;
     
     #14/10
     ($dbname) = split /\_/, $myconfig{dbname};
     $dbname =~ tr/a-z/A-Z/;
     
     #15/10 set the page number
     $pagenumber++;
     
     #16/10 show the date, time and title and the bottom
     print qq|
     <tr><td>&nbsp;</td></tr>
     <tr><td>&nbsp;</td></tr>
     </tr>
     <tr>
     <td></td>
     <td colspan=2>$form->{titlebottom}</td>
     <td></td>
     <td align=right colspan=3>$nowdate-$nowtime</td>
     </tr>
     
     <!--#14/10 changing the table-->
    
</table>
 <p style="page-break-before: always">&nbsp;</p>
 <table border=0 width=750>
	<tr>
		<td align=left width=100>
		<table border=0 width=100>
		<tr>
			<th align=left><font size=3>$dbname</font></th>
		</tr>
		<tr>
			<th align=left nowrap><font size=3>F/Y : $form->{fy}</font></th>
		</tr>
		</table>
		
		<td align=center width=600>		
		<table border=0 width=600>
		<tr>
			<th align=center><font size=3>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$form->{company}</font></th>
		</tr>
		<tr>
			<th align=center><font size=3>Records of Batch for Jan $form->{fy} - Dec $form->{fy}</font></th>
		</tr>
		</table>
		
		</td>
		<td align=right width=50 nowrap>PG. $pagenumber</td>
	</tr>
</table>

<!--#14/10 this code is not running anymore, is replaced by line from 1329 to 1345-->
 <!--p>$dbname</p>
 <p>F/Y : $form->{fy}</p>
<H1  $listprint align=center ><font size=4>$form->{company}<br>$form->{title}</font></h1-->
<table  $listprint border=0 width=100%>

<tr $listheading >|;
if($form->{l_sr}){
	print "<th $listprint ><font $listheadingcolor>".$locale->text('SR')."$line</font></th>";
}
map { print "\n$column_header{$_}" } @column_index;

print qq|
</tr><tr>
|;
if($form->{l_sr}){
	print "<td $listprint >&nbsp;</td>";
}

 	  map { $column_data{$_} = "<td $listprint >&nbsp;</td>" } @column_index;
     $column_data{accdesc} = "<td $listprint >***Subtotal B/F for Page $pagenum </td>";
     $column_data{amount} = "<td  $listprint align=right>".$form->format_amount(\%myconfig, $pagetotalamount, 2, "&nbsp;")."</td>";
    $column_data{debit} = "<td  $listprint align=right>".$form->format_amount(\%myconfig, $pagetotaldebit , 2, "&nbsp;") . "</td>";
    $column_data{credit} = "<td  $listprint align=right>".$form->format_amount(\%myconfig, $pagetotalcredit, 2, "&nbsp;") . "</td>";
    map { print "\n$column_data{$_}" } @column_index;
print qq|
</tr>
|;
$r=0;

}

  }

  &gl_subtotal if ($form->{l_subtotal} eq 'Y');
  
  
  #14/10 Change the text
  #$subtotalheading =$locale->text('Total')." For ".$form->{transtypeno}."-".$form->{batchno}."&nbsp;&nbsp;";

  map { $column_data{$_} = "<td $listprint><font $fontsize >&nbsp;</font></td>" } @column_index;
  $column_data{accno} = "<th $listprint align=right>$line<font $fontsize >".$form->format_amount(\%myconfig,$totalnotr, "&nbsp;")."$line</font></th>";
  $column_data{source} = "<th  $listprint align=center>$line<font $fontsize >".$form->format_amount(\%myconfig, $totaldif, 2, "0.00")."$line</font></th>";
  $column_data{debit} = "<th  $listprint align=right>$line<font $fontsize >".$form->format_amount(\%myconfig, $newdebit, 2, "&nbsp;")."$line</font></th>";
  $column_data{credit} = "<th  $listprint align=right>$line<font $fontsize >".$form->format_amount(\%myconfig, $newcredit, 2, "&nbsp;")."$line</font></th>";
  #$column_data{amount} = "<th  $listprint align=right>$line".$form->format_amount(\%myconfig, $pagetotalamount, 2, "&nbsp;")."$line</th>";

  if($lastline2 eq 'Y' ){
	$lastline = "<p align=right>".$locale->text('Total for BAT NO. ').$form->{transtypeno}."-".$form->{batchno}."&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; ".$form->format_amount(\%myconfig, $totaldebit, 2, "&nbsp;")."</p><br>".$lastline;
  }

  if($form->{l_total} eq 'Y'){
	  print  qq|
	  <tr $listtotal bgcolor=000000>|;
    
    	if($form->{l_sr}){
    	print "<td $listprint>&nbsp;</td>";
    }

    	map { print  "$column_data{$_}\n" } @column_index;
	print  qq|</tr>|;
  };
 
 #19/10 push the $nowdate, $nowtime to the bottom
 if($pushrow eq 'T'){
	 $countrow = $r+2;
 
 	if($countrow == 26){
		$addrows = "<tr><td>&nbsp;</td></tr>\n<tr><td>&nbsp;</td></tr>";
	}
	elsif($countrow < 26){
		$temp = $form->{rowcount}-$countrow;
		$temp =  $temp * 2 + 2;	 
		for($i=0; $i<=$temp; $i++){
			$addrows .= "<tr><td>&nbsp;</td></tr>\n";
		}
	}
 }
 elsif($pushrow eq 'F'){
	 $countrow = $r+2;
	 
 
 	if($countrow == 50){
		$addrows = "<tr><td>&nbsp;</td></tr>\n<tr><td>&nbsp;</td></tr>";
	}
	elsif($countrow < 50){
		$temp = $form->{rowcount}-$countrow;
		#$temp =  $temp * 2 + 2;	 
		for($i=0; $i<=$temp; $i++){
			$addrows .= "<tr><td>&nbsp;</td></tr>\n";
		}
	}
 }
 	print  qq|
	$addrows
	</tr>
	<tr>
	<td></td>
	<td colspan=2 align=left>$form->{titlebottom}</td>
	<td></td>
	<td align=right colspan=3></td>
	</tr>
	</table>
    	<p>
	$lastline
	</body>
	</html>
	|;
}
